function q = rotMToEulerP(Q)
    T = Q(1,1)+Q(2,2)+Q(3,3);
    R = [T,Q(1,1),Q(2,2),Q(3,3)];
    [rii,i]=max(R);
    z = zeros(4,1);
    z(i) = sqrt(1 + 2*rii - T);
    if i == 1
        z(i+1) = (Q(3,2) - Q(2,3))/z(i);
        z(i+2) = (Q(1,3) - Q(3,1))/z(i);
        z(i+3) = (Q(2,1) - Q(1,2))/z(i);
    elseif i == 2
        z(i-1) = (Q(3,2) - Q(2,3))/z(i);
        z(i+1) = (Q(1,3) - Q(3,1))/z(i-1);
        z(i+2) = (Q(2,1) - Q(1,2))/z(i-1);
    elseif i == 3
        z(i-2) = (Q(1,3) - Q(3,1))/z(i);
        z(i-1) = (Q(3,2) - Q(2,3))/z(i-2);
        z(i+1) = (Q(2,1) - Q(1,2))/z(i-2);
    elseif i == 4
        z(i-3) = (Q(2,1) - Q(1,2))/z(i);
        z(i-1) = (Q(1,3) - Q(3,1))/z(i-3);
        z(i-2) = (Q(3,2) - Q(2,3))/z(i-3);
    end
  q0 = z(1,1)/2;
  qv = z(2:4,1)./2;
  q = [q0;qv]./norm([q0;qv]);
end